<div class="animated fadeIn" xmlns="http://www.w3.org/1999/html">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{'object.account.title' | translate}}
          <span class="float-right">
            <button (click)="addAccount()" [disabled]="isCreate || isEdit"
                    class="btn btn-block btn-primary">{{'common.add' | translate}}</button></span>
        </div>
        <div class="card-body" *ngIf="accounts">
          <div class="row justify-content-between mb-2">
            <div class="col-6">
              <span class="float-left pr-3 show-entity-per-page-label">{{'common.show' | translate}}</span>
              <select (change)="onSearch()" [(ngModel)]="paging.limit" class="form-control float-left"
                      style="max-width: 70px" [disabled]="isCreate || isEdit">
                <option *ngFor="let i of PAGING_PER_PAGE" value="{{i.value}}">{{i.label}}</option>
              </select>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input type="text" [(ngModel)]="txtSearch" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="onSearch()" class="btn btn-dark" [disabled]="isCreate || isEdit">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <form [formGroup]="accountFormGroup">
            <table class="table table-bordered table-sort-icon">
              <thead>
              <tr appSort [disabled]="isCreate || isEdit" [(orderBy)]="order.orderBy" [(orderType)]="order.orderType" (orderChange)="changeOder($event)">
                <th appSortBy="name" class="text-center">
                  {{'object.account.name' | translate}}
                  <fa-icon></fa-icon></th>
                <th appSortBy="email" class="text-center">
                  {{'object.account.email' | translate}}
                  <fa-icon></fa-icon></th>
                <th appSortBy="phone" class="text-center">
                  {{'object.account.phone' | translate}}
                  <fa-icon></fa-icon></th>
                <th class="text-center">{{'common.action' | translate}}</th>
              </tr>
              </thead>
              <tbody formArrayName="data" *ngFor="let account of getFormData.controls; let i=index">
              <tr [formGroupName]="i">
                <td class="text-left">
                  <span *ngIf="!account.get('is_update').value">
                    {{account.get('name').value}}
                  </span>
                  <div *ngIf="account.get('is_update').value">
                    <input type="text" class="form-control" formControlName="name"
                           placeholder="{{'object.account.name' | translate}}" pattern="^[_.@A-Za-z0-9-]*$">
                    <div
                      *ngIf="account.get('name').invalid && account.get('name').dirty || account.get('name').touched">
                      <span class="form-text text-danger"
                            *ngIf="account.get('name').errors?.required && account.get('name').touched ">
                        {{'error.validate.input_required' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="account.get('name').errors?.pattern ">
                        {{'error.validate.pattern' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="account.get('name').errors?.minlength ">
                        {{'error.validate.name.minlength' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="account.get('name').errors?.maxlength">
                        {{'error.validate.name.maxlengthS' | translate}}
                      </span>
                    </div>
                  </div>
                </td>
                <td class="text-left">
                  <span *ngIf="!account.get('is_update').value">
                    {{account.get('email').value}}
                  </span>
                  <div *ngIf="account.get('is_update').value">
                    <input type="email" class="form-control" formControlName="email"
                           placeholder="{{'object.account.email' | translate}}" email
                           pattern="[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,3}$">
                    <span class="form-text text-danger"
                      *ngIf="account.get('email').touched && account.get('email').dirty && account.get('email').invalid">{{'error.validate.input_valid' | translate}}
                    </span>
                  </div>
                </td>
                <td class="text-right">
                  <span *ngIf="!account.get('is_update').value">
                    {{account.get('phone').value}}
                  </span>
                  <div *ngIf="account.get('is_update').value">
                    <input type="text" class="form-control" formControlName="phone"
                           placeholder="{{'object.account.phone' | translate}}"
                           pattern="^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$">
                    <div class="text-danger"
                         *ngIf="account.get('phone').invalid && account.get('phone').dirty || account.get('phone').touched">
                      <span class="form-text text-danger"
                            *ngIf="account.get('phone').errors?.pattern && account.get('phone').touched ">
                        {{'error.validate.pattern1' | translate}}
                      </span>
                    </div>
                  </div>
                </td>
                <td class="text-center">
                  <div class="btn-group">
                    <button *ngIf="!account.get('is_update').value" (click)="onEdit(i)"
                            type="submit" [disabled]="isCreate || isEdit"
                            class="btn btn-success btn-sm">
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                    </button>
                    <button *ngIf="account.get('is_update').value" (click)="save(i)" type="submit"
                            [disabled]="account.invalid || (!account.get('phone').value && !account.get('email').value)  "
                            class="btn btn-primary btn-sm">
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                    </button>
                    <button *ngIf="!account.get('is_update').value" type="submit" (click)="remove(deleteModal, i)"
                            class="btn btn-danger btn-sm" [disabled]="isCreate || isEdit">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                    </button>
                    <button *ngIf="account.get('is_update').value" type="submit" (click)="onCancelEdit(i)"
                            class="btn btn-danger btn-sm">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                    </button>
                  </div>
                </td>
              </tr>
              </tbody>
            </table>
          </form>
          <div class="row justify-content-between" *ngIf="accounts.length > 0">
            <span class="col-6">{{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + getFormData.controls.length),
              total: paging.total
            } }}</span>

            <div class="col-6">
              <ngb-pagination class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)" [disabled]="isCreate || isEdit">
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="!accounts || accounts.length === 0" class="text-center">
            <span>{{'common.no_record' | translate}}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'object.account.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'object.account.delete_popup.message' | translate: {name: selectedAccount.name} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger"
            (click)="modal.close('delete')">{{'common.delete' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>

<ng-template #saveModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-save-title">{{'object.account.save_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>

  <div class="modal-body" *ngIf="isEdit">
    {{'object.account.save_popup.message' | translate: {name: selectedAccount.name}  }}
  </div>

  <div class="modal-body" *ngIf="!isEdit">
    {{'object.account.save_popup.message1' | translate }}
  </div>

  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('save')">{{'common.save' | translate}}</button>
    <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' | translate}}
    </button>
  </div>
</ng-template>

